#include <stdio.h>
#include <stdlib.h>   //exit()  
#include <fcntl.h>    //define O_RDWR  
#include <time.h>
#include <stdlib.h>     //exit()
#include <signal.h>     //signal()

#include "DEV_Config.h"
#include "dev_hardware_i2c.h"

#define SEC    0x02  
#define MIN    0x03 
#define HOUR   0x04 
#define DAY    0x05 
#define WEEK   0x06 
#define MONTH  0x07 
#define YEAR   0x08 




char  buf[]={0x02,0x00,0x10,0x20,0x23,0x03,0x06,0x19};
char  *str[]  ={"SUN","Mon","Tues","Wed","Thur","Fri","Sat"};

void  Handler(int signo)
{
    //System Exit
    printf("\r\nHandler:Program  End\r\n");
    DEV_ModuleExit();

    exit(0);
}

void pcf8563SetTime()
{
	DEV_HARDWARE_I2C_write(buf, 8);
}
void pcf8563ReadTime() 
{
    DEV_HARDWARE_I2C_read(SEC, buf,7);  
} 

int main(int argc, char **argv)  
{
    // Exception handling:ctrl + c
    signal(SIGINT, Handler);
    
    DEV_ModuleInit();
    pcf8563SetTime();
    
    while(1){
        pcf8563ReadTime();
		buf[0] = buf[0]&0x7F; //sec
		buf[1] = buf[1]&0x7F; //min
		buf[2] = buf[2]&0x3F; //hour
		buf[3] = buf[3]&0x3F; //day
		buf[4] = buf[4]&0x07; //week
		buf[5] = buf[5]&0x1F; //mouth
		//year/month/day
		printf("20%02x/%02x/%02x  ",buf[6],buf[5],buf[3]);
		//hour:minute/second
		printf("%02x:%02x:%02x  ",buf[2],buf[1],buf[0]);
		//weekday
		printf("%s\n",str[(unsigned char)buf[4]]);
		DEV_Delay_ms(1000); 
    }
}  
