#include <stdio.h>
#include<wiringPi.h>
#include <math.h>

#define	Clock	27
#define	Address	28
#define	DataOut	29
#define D0 0

unsigned int flag_error=0;

void tlc1543_int()
{
unsigned char i;
        for (i = 0; i < flag_error; i ++)
        {
                digitalWrite(Clock,1);
                delayMicroseconds(15);
                digitalWrite(Clock,0);
                delayMicroseconds(15);
        }
}

unsigned int ADC_Read(unsigned char channel)
{
	unsigned int value;
	unsigned char i;
	unsigned char LSB = 0, MSB = 0;
 
	channel = channel << 4;
	for (i = 0; i < 4; i ++) 
	{
		if(channel & 0x80)
			digitalWrite(Address,1);
		else 
			digitalWrite(Address,0);
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
		channel = channel << 1;
	}
	for (i = 0; i < 6;i ++) 
	{
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		digitalWrite(Clock ,0);	
		delayMicroseconds(15);
	}

	delayMicroseconds(15);
	for (i = 0; i < 2; i ++) 
	{
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		MSB <<= 1;
		if (digitalRead(DataOut))
			MSB |= 0x1;
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
	} 
	for (i = 0; i < 8; i ++) 
	{
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		LSB <<= 1;
		if (digitalRead(DataOut))
			LSB |= 0x1;
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
	} 
	value = MSB;
	value <<= 8;
	value |= LSB;
	return value; 
}


int main()
{
        int tmp1,tmp2,tmp3,tmp4,tmp5,tmp6;
        int k1,k2,k3,k4,k5;
        int  value_ad;

	if (wiringPiSetup() < 0)return 1 ;

	pinMode (DataOut,INPUT);
	pullUpDnControl(DataOut, PUD_UP);

	pinMode(Clock,OUTPUT);
	pinMode(Address,OUTPUT);
     
	pinMode(D0,INPUT);
	digitalWrite(D0,0);

	while(1)
	{
        tlc1543_int();

        tmp1=ADC_Read(6);
        delay(1);
        tmp2=ADC_Read(6);
        delay(1);
        tmp3=ADC_Read(6);
        delay(1);
        tmp4=ADC_Read(6);
        delay(1);
        tmp5=ADC_Read(6);
        delay(1);
        tmp6=ADC_Read(6);
        delay(1);
        k1=fabs(tmp2-tmp1);
        k2=fabs(tmp3-tmp2);
        k3=fabs(tmp4-tmp3);
        k4=fabs(tmp5-tmp4);
        k5=fabs(tmp6-tmp5);
	if(digitalRead(D0) == LOW)
	{
		printf("Near field !!!\n");
		//if( 100< value_ad && value_ad< 300)
		//{
		printf("AD: %d \n",ADC_Read(6));
		//}
	}
	else
	{
		printf("Far Field\n");
	}


        if ( ( k1>80 && k2>80 && k3>80 && k4>80 && k5>80 )  )
           {
                flag_error=flag_error+1;
                if (flag_error==21){flag_error=0;}
//                printf("Busy or Not give a Voltage at Pin T_A6\n");
                //delay(1);
            }
        else if ( k1<=100 && k2<=100 && k3<=100 && k4<=100 && k5<=100 )
           {
              flag_error=0;
	      if(digitalRead(D0) == HIGH)
	      {
	      		value_ad=(tmp1+tmp2+tmp3+tmp4+tmp5+tmp6)/6;
              		printf("AD: %d \n",value_ad);
              		delay(100);
	      }
            }
        else
           {
             flag_error=0;
	    //flag_error=flag_error+1;
	     if (flag_error==21){flag_error=0;}
//	     printf("ERR: %d \n",ADC_Read(6));
//	    delay(100);
            }

        }		

}
