#include <stdio.h>
#include <math.h>
#include <bcm2835.h>

#define	Clock	16
#define	Address	20
#define	DataOut	21

unsigned int flag_error=0;

void tlc1543_int()
{
unsigned char i;
 	for (i = 0; i < flag_error; i ++)
        {
                bcm2835_gpio_write(Clock ,1);
                delayMicroseconds(15);
                bcm2835_gpio_write(Clock ,0);
                delayMicroseconds(15);
        }
}

unsigned int ADC_Read(unsigned char channel)
{
	unsigned int value;
	unsigned char i;
	unsigned char LSB = 0, MSB = 0;
 	//bcm2835_delay(100);
	channel = channel << 4;
	for (i = 0; i < 4; i ++) 
	{
		if(channel & 0x80)
			bcm2835_gpio_write(Address,1);
		else 
			bcm2835_gpio_write(Address,0);
		bcm2835_gpio_write(Clock ,1);
		delayMicroseconds(15);
		bcm2835_gpio_write(Clock ,0);
		delayMicroseconds(15);
		channel = channel << 1;
	}
	for (i = 0; i < 6;i ++) 
	{
		bcm2835_gpio_write(Clock ,1);
		delayMicroseconds(15);
		bcm2835_gpio_write(Clock ,0);
		delayMicroseconds(15);
	}

	delayMicroseconds(15);
	//bcm2835_delay(100);
	
	for (i = 0; i < 2; i ++) 
	{
		bcm2835_gpio_write(Clock ,1);
		delayMicroseconds(15);
		MSB <<= 1;
		if (bcm2835_gpio_lev(DataOut))
			MSB |= 0x1;
		delayMicroseconds(15);
		bcm2835_gpio_write(Clock ,0);
		delayMicroseconds(15);
	} 
	for (i = 0; i < 8; i ++) 
	{
		bcm2835_gpio_write(Clock ,1);
		delayMicroseconds(15);
		LSB <<= 1;
		if (bcm2835_gpio_lev(DataOut))
			LSB |= 0x1;
		delayMicroseconds(20);
		bcm2835_gpio_write(Clock ,0);
		delayMicroseconds(15);
	} 
	value = MSB;
	value <<= 8;
	value |= LSB;
	return value; 
}


int main()
{
        unsigned int tmp1,tmp2,tmp3,tmp4,tmp5,tmp6;
        unsigned int k1,k2,k3,k4,k5;
//	unsigned int flag_error=0;

	if (!bcm2835_init())return 1 ;

	bcm2835_gpio_fsel(DataOut,BCM2835_GPIO_FSEL_INPT);
	bcm2835_gpio_set_pud(DataOut, BCM2835_GPIO_PUD_UP);

	bcm2835_gpio_fsel(Clock,BCM2835_GPIO_FSEL_OUTP);
//	bcm2835_gpio_set_pud(Clock, BCM2835_GPIO_PUD_UP);
	bcm2835_gpio_fsel(Address,BCM2835_GPIO_FSEL_OUTP);
//	bcm2835_gpio_set_pud(Address, BCM2835_GPIO_PUD_UP);


	while(1)
	{
	tlc1543_int();

	tmp1=ADC_Read(6);
	bcm2835_delay(10);
	tmp2=ADC_Read(6);
        bcm2835_delay(10);
        tmp3=ADC_Read(6);
        bcm2835_delay(10);
        tmp4=ADC_Read(6);
        bcm2835_delay(10);
        tmp5=ADC_Read(6);
        bcm2835_delay(10);
        tmp6=ADC_Read(6);
        bcm2835_delay(10);
	k1=abs(tmp2-tmp1);
	k2=abs(tmp3-tmp2);
        k3=abs(tmp4-tmp3);
	k4=abs(tmp5-tmp4);
        k5=abs(tmp6-tmp5);
	if ( k1>5 && k2>5 && k3>5 && k4>5 && k5>5 )
	   {
		flag_error=flag_error+1;
		if (flag_error==21){flag_error=0;}
 		printf("Busy..");
		bcm2835_delay(1);
	    }
        else if ( k1<5 && k2<5 && k3<5 && k4<5 && k5<5 )
           {
              flag_error=0;
              printf("AD: %d \n",ADC_Read(6));
              bcm2835_delay(500);
            }
        else 
           {
              flag_error=0;
              printf("Error: %d \n",ADC_Read(6));
              bcm2835_delay(1);
            }

  	}
	
	bcm2835_close();
	return 0;
}
