#include <stdio.h>
#include <math.h>
#include<wiringPi.h>

#define	Clock	27
#define	Address	28
#define	DataOut	29

#define CHANNEL 6 // selector channel

unsigned int flag_error=0;

void tlc1543_int()
{
unsigned char i;
 	for (i = 0; i < flag_error; i ++)
        {
                digitalWrite(Clock,1);
		delayMicroseconds(15);
                digitalWrite(Clock,0);
                delayMicroseconds(15);
        }
}

unsigned int ADC_Read(unsigned char channel)
{
	unsigned int value;
	unsigned char i;
	unsigned char LSB = 0, MSB = 0;
 
	channel = channel << 4;
	for (i = 0; i < 4; i ++) 
	{
		if(channel & 0x80)
			digitalWrite(Address,1);
		else 
			digitalWrite(Address,0);
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
		channel = channel << 1;
	}
	for (i = 0; i < 6;i ++) 
	{
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
	}

	delayMicroseconds(15);
	for (i = 0; i < 2; i ++) 
	{
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		MSB <<= 1;
		if (digitalRead(DataOut))
			MSB |= 0x1;
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
	} 
	for (i = 0; i < 8; i ++) 
	{
		digitalWrite(Clock ,1);
		delayMicroseconds(15);
		LSB <<= 1;
		if (digitalRead(DataOut))
			LSB |= 0x1;
		digitalWrite(Clock ,0);
		delayMicroseconds(15);
	} 
	value = MSB;
	value <<= 8;
	value |= LSB;
	return value; 
}


int main()
{
        int tmp1,tmp2,tmp3,tmp4,tmp5,tmp6;
        int k1,k2,k3,k4,k5;
	int  value_ad;

	if (wiringPiSetup() < 0)return 1 ;

	pinMode (DataOut,INPUT);
	pullUpDnControl(DataOut, PUD_UP);

	pinMode (Clock,OUTPUT);
	pinMode (Address,OUTPUT);


	while(1)
	{

	tlc1543_int();

	tmp1=ADC_Read(CHANNEL);
	delay(10);
	tmp2=ADC_Read(CHANNEL);
        delay(10);
        tmp3=ADC_Read(CHANNEL);
        delay(10);
        tmp4=ADC_Read(CHANNEL);
        delay(10);
        tmp5=ADC_Read(CHANNEL);
        delay(10);
        tmp6=ADC_Read(CHANNEL);
        delay(10);
	k1=fabs(tmp2-tmp1);
	k2=fabs(tmp3-tmp2);
        k3=fabs(tmp4-tmp3);
	k4=fabs(tmp5-tmp4);
        k5=fabs(tmp6-tmp5);
	if ( k1>5 && k2>5 && k3>5 && k4>5 && k5>5 )
	   {
		flag_error=flag_error+1;
		if (flag_error==21){flag_error=0;}
 		printf("Busy or Not give a Voltage at Pin T_A%d\n",CHANNEL);
		delay(1);
	    }
        else if ( k1<5 && k2<5 && k3<5 && k4<5 && k5<5 )
           {
              flag_error=0;
	      value_ad=(tmp1+tmp2+tmp3+tmp4+tmp5+tmp6)/6;
              printf("AD: %d \n",value_ad);
              delay(500);
            }
        else 
           {
              flag_error=0;
//              printf("Error: %d \n",ADC_Read(6));
//             bcm2835_delay(1);
            }

//  		printf("AD: %d \n",ADC_Read(6));
//		delay(500);
  	}
}
